/**
  ******************************************************************************
  * @file UART2_Printf\main.c
  * @brief This file contains the main function for: retarget the C library printf
  *        /scanf functions to the UART2 example.
  * @author  MCD Application Team
  * @version V2.0.0
  * @date    25-February-2011
  *******************************************************************************/ 

/* Includes ------------------------------------------------------------------*/
#include "nRF24L01.h"
#include "stm8s.h"
#include "stdio.h"
#include "STM8_LCD.h"
/**
  * @addtogroup UART2_Printf
  * @{
  */
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
 /* _IAR_ */
#define PUTCHAR_PROTOTYPE int putchar (int c)
#define GETCHAR_PROTOTYPE int getchar (void)
 /* _RAISONANCE_ */
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
unsigned char RxBuf[5]={0x00,0x00,0x00,0x00,0x00};
/*void delayms(unsigned int time) 
{ 
    unsigned int i; 
    while(time--)   
    for(i=900;i>0;i--) 
    inerDelay_us(1);
} */

void GPIO_Configuration(void)
{
    //ģIOڳʼ 
    //MISO ȡ  룬ûⲿж
    GPIO_Init(NRF24L01_CE_PORT, (GPIO_Pin_TypeDef)(NRF24L01_CE_PIN ), GPIO_MODE_OUT_PP_HIGH_FAST);//ce 
    GPIO_Init(NRF24L01_CS_PORT, (GPIO_Pin_TypeDef)(NRF24L01_CS_PIN ), GPIO_MODE_OUT_PP_HIGH_FAST);//cs
    GPIO_Init(NRF24L01_SCK_PORT, (GPIO_Pin_TypeDef)(NRF24L01_SCK_PIN ), GPIO_MODE_OUT_PP_HIGH_FAST);//sck
    GPIO_Init(NRF24L01_MOSI_PORT, (GPIO_Pin_TypeDef)(NRF24L01_MOSI_PIN ), GPIO_MODE_OUT_PP_HIGH_FAST);//MOSI
    GPIO_Init(NRF24L01_MISO_PORT, (GPIO_Pin_TypeDef)(NRF24L01_MISO_PIN), GPIO_MODE_IN_FL_NO_IT);//MISO
    GPIO_Init(NRF24L01_IRQ_PORT, (GPIO_Pin_TypeDef)(NRF24L01_IRQ_PIN ), GPIO_MODE_IN_FL_NO_IT); //IRQ
    
     // GPIO_Init(NRF24L01_MISO_PORT, (GPIO_Pin_TypeDef)(NRF24L01_MISO_PIN), GPIO_MODE_OUT_PP_HIGH_FAST);//MISO
    //GPIO_Init(NRF24L01_IRQ_PORT, (GPIO_Pin_TypeDef)(NRF24L01_IRQ_PIN ), GPIO_MODE_OUT_PP_HIGH_FAST); //IRQ
   
}

void LED_GPIO_Configuration(void)
{
     GPIO_Init(GPIOA, (GPIO_Pin_TypeDef)(GPIO_PIN_6), GPIO_MODE_OUT_PP_HIGH_FAST);//LED  PA6
     GPIO_WriteLow(GPIOA, GPIO_PIN_6);
}

void Delay(uint16_t nCount)
{
  /* Decrement nCount value */
  while (nCount != 0)
  {
    nCount--;
  }
}

void init_io(void)
{
    delayms(2000); 	 //ʱ 100us
    GPIO_WriteHigh(NRF24L01_CE_PORT, NRF24L01_CE_PIN);
    GPIO_WriteHigh(NRF24L01_CS_PORT, NRF24L01_CS_PIN);
    GPIO_WriteLow(NRF24L01_SCK_PORT, NRF24L01_SCK_PIN);
}

 
void NRF24_SPI_Init(void)
{
    SPI_DeInit();
    /* Initialize SPI in Slave mode  */
    SPI_Init(SPI_FIRSTBIT_MSB, SPI_BAUDRATEPRESCALER_2, SPI_MODE_MASTER, SPI_CLOCKPOLARITY_LOW,
             SPI_CLOCKPHASE_1EDGE, SPI_DATADIRECTION_2LINES_FULLDUPLEX, SPI_NSS_SOFT,(uint8_t)0x07);  
    /* Enable the SPI*/
    SPI_Cmd(ENABLE);
}

void Action_Init(void)
{
  CLK_HSIPrescalerConfig(CLK_PRESCALER_HSIDIV1); //16MHzڲRC(HSI)
  LCD_GPIO_Configuration(); 
  GPIO_Configuration(); //NRF24L01
  NRF24_SPI_Init();
  init_io();
  LCD_GPIO_Configuration();
  LCD_init();
  LCD_clear();
  LED_GPIO_Configuration();
}

void main(void)
{
        Action_Init();
        unsigned char i;
        RX_Mode();
        while(1)
        { 
            /* ǰͷ ------------------------------------------------------*/
            while(NRF24L01_Check())  //0־⵽豸,1ʾⲻ豸
            {      
               LCD_Display_Check();//豸δװ
            }
            LCD_clear();
            while(1)
            {
              LCD_Display_Name();
              i++;
              if(i==0xffff)
                {
                  i=0;
                  GPIO_WriteReverse(GPIOA, GPIO_PIN_6);
                }
                
              if(nRF24L01_RxPacket(RxBuf)==1)  //1 ʾյ
              {  
                GPIO_WriteHigh(GPIOA, GPIO_PIN_6);
                if(RxBuf[0]==0x01)  /////
                  { 
                    LCD_clear();
                    LCD_Display_Name();
                    LCD_Display_Close();
                  }
                if(RxBuf[0]==0x02)  ////
                  { 
                    LCD_clear();
                    LCD_Display_Name();
                    LCD_Display_Open();
                  }
                if(RxBuf[0]==0x03)  /////
                  { 
                    LCD_clear();
                    LCD_Display_Name();
                    LCD_Display_Alarm();    
                    delayms(200);
                    
                  }
              }
        }  
        
    } //while
}

          //if(nRF24L01_TxPacket(TxBuf)==TX_OK)
                 //           
               //   GPIO_WriteHigh(GPIOA, GPIO_PIN_6);
                //  delayms(200);  //ʱ
                //  GPIO_WriteLow(GPIOA, GPIO_PIN_6);
                //  delayms(200);        
/**
  * @brief Retargets the C library printf function to the UART.
  * @param c Character to send
  * @retval char Character sent
  */
PUTCHAR_PROTOTYPE
{
  /* Write a character to the UART2 */
  UART2_SendData8(c);
  /* Loop until the end of transmission */
  while (UART2_GetFlagStatus(UART2_FLAG_TXE) == RESET);

  return (c);
}

/**
  * @brief Retargets the C library scanf function to the USART.
  * @param None
  * @retval char Character to Read
  */
GETCHAR_PROTOTYPE
{
#ifdef _COSMIC_
  char c = 0;
#else
  int c = 0;
#endif
  /* Loop until the Read data register flag is SET */
  while (UART2_GetFlagStatus(UART2_FLAG_RXNE) == RESET);
    c = UART2_ReceiveData8();
  return (c);
}

#ifdef USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}


#endif

/**
  * @}
  */

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/



